/******************************************************************************
*                                                                             *
*   t i c o n s t                                                             *
*                                                                             *
*   by Stefan Heule                                                           *
*   http://stefanheule.com                                                    *
*                                                                             *
*   Source Code                                                               *
*                                                                             *
*******************************************************************************

ticonst - replacement for the standard units menu
Copyright (C) 2009-2010 Stefan Heule

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/



// ----------------------------------------------------------------- //
// --- header files
// ----------------------------------------------------------------- //
#include "header.h"


// ----------------------------------------------------------------- //
// checks for keypresses and turns the calc of if APD expired
// ----------------------------------------------------------------- //
short getKey(short allow_repeat)
{
	void *kbq = kbd_queue();
	unsigned short key;
	
	// restart the APD timer now
	restart:
	OSTimerRestart(APD_TIMER);
	
	// get an input
	while (OSdequeue(&key, kbq))
	{
		// check if it is necessary to turn the calc off
		if (OSTimerExpired(APD_TIMER))
		{
			off();
			OSTimerRestart(APD_TIMER);
		}
	}
	
	if (!allow_repeat && key & 0x0800) goto restart;
	
	// erase the status line
	ST_eraseHelp();
	
	// allow key repetition
	return key & 0xF7FF;
}

// ----------------------------------------------------------------- //
// fast replacement for kbhit()
// ----------------------------------------------------------------- //
short isKeyWaiting(void)
{
	unsigned short key;
	return OSqinquire(&key,kbd_queue());
}
















